###############################################################################
# Adapted from the code for Digital Grotesque originaly written in Processing #
# Benjamin Dillenburger, Michael Hansmeyer and Mathias Bernhard               #
# Digital Building Technologies, ETH Zurich, 2018                             #
###############################################################################

def export_obj(mesh,filename="output.obj"):
    
    file = open(filename,"w") 
    
    file.write("# adapted from p5py library by Mathias Bernhard\n")
    file.write("# rewritten for Rhino by Luka Piskorec\n")
    
    mesh.collect_nodes()
    
    for n in mesh.nodes:
        file.write("v {} {} {}\n".format(n.x,n.y,n.z))
    
    file.write("g triangles\n")
    tris = [f for f in mesh.faces if len(f.nodes)==3]
    
    for f in tris:
        index_list = [str(n.id) for n in f.nodes]
        file.write("f "+" ".join(index_list)+"\n")
    
    file.write("g quads\n")
    quads = [f for f in mesh.faces if len(f.nodes)==4]
    for f in quads:
        index_list = [str(n.id) for n in f.nodes]
        file.write("f "+" ".join(index_list)+"\n")
    
    file.flush()
    file.close()